function [zz]=cts_bbq(z,i,j,a) %A: added zz as output of fct
% ********************************************************************
% Procedure CTS_OKUN implements the extended OKUN dating              
% rule that two  quarters of positive growth terminates a contraction 
% To use this procedure in GETDATE set the following parameters       
%       k=2                                                           
%       l=2                                                           
%       a_ETS={} (null) - not used                                    
% NOTE DESIGNED FOR QUARTERLY DATA ONLY                               
% ********************************************************************
tz=max([rows(z);cols(z)]);
if j==i ;
%Then must be away from end-point problems
      zz=(min(z)==z(i)); %A: retp(max(z)==z(i));
else
%AT beginning or end of data 
    if(i>3) && ((tz-i)>=2);
        zz=(min(z)==z(i)); %A: retp(max(z)==z(i));
    else
        zz=0; %A: retp(0);
    end;
end;
end

