function [zz]=cts_okun(z,i,j,a)
% ********************************************************************
% Procedure CTS_OKUN implements the extended OKUN dating              
% rule that two  quarters of positive growth terminates a contraction 
% To use this procedure in GETDATE set the following parameters       
%       k=0                                                           
%       l=2                                                           
%       i and j are redundant                                         
%       a_ETS={} (null) - not used                                    
% NOTE DESIGNED FOR QUARTERLY DATA ONLY                               
% ********************************************************************
if rows(z)*cols(z)==3;
       %A: retp((z(1)<z(2))&(z(2)<z(3)));
       zz=((z(1)<z(2))&(z(2)<z(3)));
else
    zz=NaN;
end;
end