function [bcp,bct]=enfvcp(bcp,bct,x)
% ************************************************************************
% Procedure ENFVCP eliminates peaks (and troughs) at both ends which are  
% lower (or higher) than values closer to end / Alain Schlaepfer (2010): 
% similar to original ENFVC, but adjusted for refcycle procedure
% ************************************************************************
%top:...
% Check First Date

% A: replaced 'goto top' cycle with a while / else break loop for w and v

if (size(bcp,1)==0 && size(bct,1)==0);
        return;
end;

w=0;
v=0;
while v==0;
while w==0;
    if (size(bcp,1)==0 && size(bct,1)==0);
        return;
    end;
    m=min([bcp;bct]);
    if m==min(bcp);
    % First TP is a peak 
         s=zeros(rows(bcp),1);
         d1=bcp(1,1);
         if x(1,1)>x(d1,1);
             s(1,1)=1;
             bcp=delif(bcp,s);
             %goto top;
         else
             break
         end;
    else
    % First TP is a trough 
         s=zeros(rows(bct),1);
         d1=bct(1,1);
         if x(1,1)<x(d1,1);
               s(1,1)=1;
               bct=delif(bct,s);
               %goto top;
         else
             break
         end;
    end;
end;
% Check last Date
if (size(bcp,1)==0 && size(bct,1)==0);
        return;
end;
m=max([bcp;bct]);

    if m==max(bcp);
    % Last TP is a peak 
         s=zeros(rows(bcp),1);
         d1=bcp(rows(bcp),1);
         if x(rows(x),1)>x(d1,1);
              s(rows(bcp),1)=1;
              bcp=delif(bcp,s);
               %goto top;
         else
                 break
         end;
    else
    % last TP is a trough 
         s=zeros(rows(bct),1);
         d1=bct(rows(bct),1);
         if x(rows(x),1)<x(d1,1);
              s(rows(bct),1)=1;
              bct=delif(bct,s);
              % goto top;
         else
                 break
         end;
    end;
end;
% Make Sure Date Alternate
[bcp,bct]=alter2(bcp,bct,x);
end