function [bcp,bct]=enfve_dh(bcp,bct,x)
% ************************************************************************
% Procedure ENFVE_dh eliminate phases less than 2 quarters duration.      
%  lowest troughs and highest peaks are saved                             
% INPUTS are:                                                             
%    - bcp                                                                
%    - bct                                                                
%    - x                                                                  
% OUTPUTS are:                                                            
%    - bcp*                                                               
%    - bct*         
global print_censor minphase;
if print_censor==0;
'enforcing minimum phase length...';
end;
% This follows the BB Code, subroutine TP3 (lines 0250-580)
%   If a violation is found the two turning points are eliminated.
%   If the violation occurs at the last turning point, then only
%   the last turn is eliminated

% Skip this procedure if either bcpn or bctn contain missing values
%if ((scalmiss(bcp)==1);(scalmiss(bct)==1));
%ret2=(bcp
%ret3=bc
%end;
pisnan=1*isnan(bcp);
tisnan=1*isnan(bct);
if ((pisnan'*pisnan~=0) | (tisnan'*tisnan~=0));
        return;
end;  


bcp=[bcp ones(rows(bcp),1)];
bct=[bct zeros(rows(bct),1)];
anmat=sortrows(([bcp;bct]),1);
nv=0;

% Check all phases except last
j=1;
while j<=(rows(anmat)-2);
    bcp=[bcp ones(rows(bcp),1)];
    bct=[bct zeros(rows(bct),1)];
    anmat=sortrows(([bcp;bct]),1);
    if j+1>(rows(anmat)-1);
       break;
    % This is included because dates and anmat is modified in loop 
    end;
    cind=anmat(j,1);
    nind=anmat(j+1,1);
    if(nind-cind)<minphase;
       nv=1;
       if print_censor==1;
            'phase too short--eliminating both turns'
          if(anmat(j,2)==1);
             'peak at'%anmat(j,1);
          else
             'trough at'%anmat(j,1);
          end;


          if anmat(j+1,2)==1;
             'peak at'%anmat(j+1,1);
          else
             'trough at'%anmat(j+1,1);
          end;
       end;
       s=zeros(rows(anmat),1);
       s(j,1)=1;
       s(j+1,1)=1;
       anmat=delif(anmat,s);
       bcp=selif(anmat,anmat(:,2)>0);
       bct=selif(anmat,anmat(:,2)<1);
       pisnan=1*isnan(bcp);
       tisnan=1*isnan(bct);
       if ((pisnan'*pisnan~=0) | (tisnan'*tisnan~=0));
        return;
       end;  
 %      [if(scalmiss(bcp)==1);scalmiss(bct)]==1);
%ret2=(bcp
%ret3=bc
%    end;
    %j=j-1; %%%%%%%%%%added Alain
    end;
j=j+1;
end;
% -- Check Final Phase --
    if (rows(anmat)>1);
    cind=anmat(rows(anmat)-1,1);
    nind=anmat(rows(anmat),1);
    if(nind-cind)<minphase;
        nv=1;
            if print_censor==1;
               'phase too short--eliminating final turn'
                if anmat(rows(anmat),2)==1;
               'peak at'%anmat(rows(anmat),1);
                else
               'trough at'%anmat(rows(anmat),1);
                end;
            end;
            anmat=anmat(1:rows(anmat)-1,:);
            bcp=selif(anmat,anmat(:,2)>0);
            bct=selif(anmat,anmat(:,2)<1);
            pisnan=1*isnan(bcp);
            tisnan=1*isnan(bct);
            if ((pisnan'*pisnan~=0) | (tisnan'*tisnan~=0));
                return;
            end;  
            %if([(scalmiss(bcp)==1);scalmiss(bct)==1]));
%ret2=(bcp
%ret3=bc
 %       end;
    end;
    end;
if nv==0;
    if print_censor==1;
          'no violation of minimum phase length found'
    end;
end;
bcp=bcp(:,1);
bct=bct(:,1);
end