%written byAlain Schlaepfer (2010)
%computes peaks and troughs of a reference cycle (see Harding and Pagan
%(2006))
%Inputs:
%mp and mt are the series to date, so to replicate HP, mp is the median 
%distance to a peak and mt is the median distance to a trough 
%q's are higher order measures used to break ties



function [refpeaks, reftroughs]=refdate(mp, mt, q1p, q2p, q3p, q4p, q1t, q2t, q3t, q4t)

n=rows(mp);
s=0;
cand=[];
candl=[];
for i=3:(n-2);
    if mp(i,1)<(mp(i-1,1)-0.001);
        cand=[i];
        s=1;
    elseif mp(i,1)==mp(i-1,1);
        if s==1;
            cand=[cand; i];
        end;
    else
        if s==0;
            cand=[];
        else
            if rows(cand)>1;
                [cand]=tiebreak(cand, q1p);
                if rows(cand)>1;
                    [cand]=tiebreak(cand, q2p);
                    if rows(cand)>1;
                        [cand]=tiebreak(cand, q3p);
                        if rows(cand)>1;
                            [cand]=tiebreak(cand, q4p);
                            if rows(cand)>1;
                                disp('unresolved tiebreak in peaks')
                                cand=cand(1,1);
                            end;
                        end;
                    end;
                end;
            end;
            candl=[candl; cand];
            s=0;
        end;
    end;
    %also do procedure for last period
    if (i==n-2) && s==1;
        if rows(cand)>1;
                [cand]=tiebreak(cand, q1p);
                if rows(cand)>1;
                    [cand]=tiebreak(cand, q2p);
                    if rows(cand)>1;
                        [cand]=tiebreak(cand, q3p);
                        if rows(cand)>1;
                            [cand]=tiebreak(cand, q4p);
                            if rows(cand)>1;
                                disp('unresolved tiebreak in peaks')
                                cand=cand(1,1);
                            end;
                        end;
                    end;
                end;
        end;
        candl=[candl; cand];
    end;            
end;
refpeaks=candl;

%repeat for troughs
n=rows(mt);
s=0;
cand=[];
candl=[];
for i=3:(n-2);
    if mt(i,1)<mt(i-1,1);
        cand=[i];
        s=1;
    elseif mt(i,1)==mt(i-1,1);
        if s==1;
            cand=[cand; i];
        end;
    else
        if s==0;
            cand=[];
        else
            if rows(cand)>1;
                [cand]=tiebreak(cand, q1t);
                if rows(cand)>1;
                    [cand]=tiebreak(cand, q2t);
                     if rows(cand)>1;
                        [cand]=tiebreak(cand, q3t);
                        if rows(cand)>1;
                            [cand]=tiebreak(cand, q4t);
                            if rows(cand)>1;
                                disp('unresolved tiebreak in troughs')
                                cand=cand(1,1);
                            end;
                        end;
                    end;
                end;
            end;
            candl=[candl; cand];
            s=0;
        end;
    end;
    if (i==n-2) && s==1;
        if rows(cand)>1;
            [cand]=tiebreak(cand, q1t);
            if rows(cand)>1;
                [cand]=tiebreak(cand, q2t);
                if rows(cand)>1;
                   [cand]=tiebreak(cand, q3t);
                   if rows(cand)>1;
                       [cand]=tiebreak(cand, q4t);
                       if rows(cand)>1;
                           disp('unresolved tiebreak in troughs')
                           cand=cand(1,1);
                       end;
                   end;
                end;
            end;
        end;
        candl=[candl; cand];
    end;
end;

reftroughs=candl;
end
        