%Alain Schlaepfer (2010), computes regional cycle, uses refcycle

%Inputs are:
% icycles: matrix of turning points of individual series
%method: method used for aggreagation: 1=median; 2=weighted mean;
% 3=minimum
%ref2: if ref2==1, refcycle only computed if at least 2 series available 
%weights: used to compute weighted meanref cycle, only used if methods=2
%Note: weights automatically adjusted such that sum=1 each period

function [rcycle, refs]=regcycle(icycles, method, ref2, weights)
%ref cycle over regions

% +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
%

%reduce to time with at least 2 series of data
addl=0;
if ref2==1;
    icyclesred=selif(icycles,sum(isnan(icycles),2)<size(icycles,2)-1);
    check=sum(isnan(icycles(end,:)),2);
    while check>=(size(icycles,2)-1);
        addl=addl+1;
        check=sum(isnan(icycles(end-addl,:)),2);
    end;
else
    icyclesred=icycles;
end;

[refpeaks, reftroughs, refs]=refcycle(icyclesred, weights, method);
rcycle=refpeaks-reftroughs;

for j=1:rows(rcycle);
     if isnan(icycles(j,:))==1;
         rcycle(j)=NaN;
     end;
end;
refs(isnan(rcycle)==1)=NaN;

%add NaN at end if it was deleted before
rcycle1=[icyclesred rcycle];
if addl>0;
    add=icycles(end+1-addl:end,:);
    add2=ones(addl,1)*NaN;
    add=[add add2];
    rcycle1=[rcycle1; add];
end;
rcycle=rcycle1;
refs(isnan(rcycle)==1)=NaN;

end