function [stripped_peaks,stripped_troughs]=strip_zeros(peaks,troughs)
% ************************************************************************
% Author Don Harding                                                      
% This procedure takes two T by 1 vectors (Peaks and Troughs) as input         
% These vectors have zeros at dates where no turning point occurs         
%      and non zero values at respective turning points                   
% Output from the procedure is as follows                                      
%   Stripped_peaks:     which has dimension number of peaks by one        
%                       and indicates the obsevation number of each peak  
%   Stripped_Troughs:   Which has dimension number of troughs by one      
%                       and indicates the observation number of each troug
% ************************************************************************
t=rows(peaks);
stripped_peaks=[];
stripped_troughs=[];
if t==rows(troughs);
      i=1;
      while i<=t;
          if peaks(i)~=0;
              stripped_peaks=[stripped_peaks;i];
          end;
          if troughs(i)~=0;
              stripped_troughs=[stripped_troughs;i];
          end;
      i=i+1;
      end;   
else
    'error rows dont match in strip_peaks procs';
    stripped_peaks=0;
    stripped_troughs=0;
end;
end
