%Alain Schlaepfer (2010)
%computes average duration of booms and recession for each country
%Needs refcycle output from bbq2008P.m as input

%Output: File, matrix 'avdur' contains for each country: 
%average duration of booms overall
%average duration of recession overall
%average duration of booms up to 2000
%average duration of recessionup to 2000
%average duration of booms after 2000
%average duration of recession after 2000

clear all

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%adjust control variables
%list of countries used
countries={'france'; 'italy'; 'spain'; 'portugal'; 'greece';...
'cyprus';'croatia'; 'slovenia'; 'serbia'; 'macedonia';...
'malta'; 'turkey'; 'israel';'lebanon';...
'jordan';'egypt'; 'algeria'; 'morocco'; 'tunisia'};
%date to split sample (2010q1-splitdate), eq. 2000q4/2001q1 = 36
splitdate=36;

%choose name of outputfile
savefile  = 'durationall';
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


countries=sort(countries);
avdur=[];



for i=1:rows(countries);
    icon=[char(countries(i)),'TP'];
    load (icon);
    %extract reference cycle for country
    indic=selif(refindic,isnan(refindic)==0);
    [tpdall, ptdall]=avduration(indic);
    %after 2000
    if size(indic,1)>splitdate;
        indicafter=indic(end-splitdate:end,:);
    else
        indicafter=indic;
    end;
    %up to 2000
    if size(indic,1)>splitdate+1;
        indicup=indic(1:end-splitdate-1,:);
    else
        indicup=NaN;
    end;
    [tpdup, ptdup]=avduration(indicup);
    [tpdafter, ptdafter]=avduration(indicafter);
    idur=[tpdall; ptdall;tpdup; ptdup;tpdafter; ptdafter];
    avdur=[avdur idur];
end;

save(savefile, 'avdur', 'countries');