%Alain Schlaepfer (2010)
%computes regional reference cycle (as in Pagan, Harding (2004)).

%Input used:
%Ouput from bbq2008.m ('countryname'TP.mat for each country)
%regbase.m for definition of regions
%regcycle.m

%Ouput: File 'regionname'ref with refcycle
clear all

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                           ADJUST CONTROL VARIABLES
global mincycle minphase print_censor;
mincycle=5;
%minimum cycle length
minphase=2;
%minimum phase length
print_censor=1;

%denote whether to compute refcycle only if at least 2 series available
%(ref2==1)
%seperate choice for each region
ref2=[1; 0; 1; 0; 0];

%enter desired regions and number of regions defined; see function
%'regbase.m' for definition of regions
x=3;
nregions=5;
[region1, region2, region3, region4, region5 ,names]=regbase(x);

method=2;
%method used to compute reference cycle, 1:median distance, 2:mean
%distance, 3: min

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for j=1:nregions;
is=[];
icycles=[];
mes=zeros(500,1);
mes(:,1)=NaN;
exmin=500;

region=eval((['region' num2str(j)]));
for i=1:rows(region);
    icon=[char(region(i)),'TP'];
    %load country turning points
    load (icon);
    ies=mes;
    icyc=mes;
    ics=mes;
    %extract country reference cycle, add sufficient at beginning such that
    %all country cycles of the region will have same length
    ex=500-rows(refindic)+1;
    exmin=min(exmin,ex);
    ies(ex:end)=0;
    icyc(ies==0)=refindic;
    ics(ies==0)=refs;
    icycles=[icycles icyc];
    is=[is ics];
end;
icycles=icycles(exmin:end,:);
weights=ones(size(icycles,2),1);
%start regional reference cycle dating
[rcycle, refs]=regcycle(icycles, method, ref2(j), weights);


%save refcycle
region=[char(names(j))];
savefile  = [region,'ref']
save(savefile, 'rcycle', 'refs');
end;
